//---------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>

#pragma hdrstop
#include "MdiMain.h"
#include "MdiAbout.h"
//---------------------------------------------------------------
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------
const int   HistCount = 4;
const char *RegKey = "Software\\Borland\\HistoryList";
//---------------------------------------------------------------
//   
__fastcall TMainForm::TMainForm(TComponent *Owner) : TForm(Owner)
{
  ChildList = new TList;            //   ChildList
}
//---------------------------------------------------------------
//    c   OnCreate
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  DragAcceptFiles(Handle, true);    //    

  HistList = new TStringList;       //   HistList
  TRegistry *reg = new TRegistry;   //   reg
  if (!reg->OpenKey(RegKey, false))
  { //  RegKey   -   
    reg->OpenKey(RegKey, true);     //   RegKey
    reg->WriteString("Hist1", "");  //  1- 
    reg->WriteString("Hist2", "");  //  2- 
    reg->WriteString("Hist3", "");  //  3- 
    reg->WriteString("Hist4", "");  //  4- 
  }
  //   HistList   
  HistList->Add(reg->ReadString("Hist1"));
  HistList->Add(reg->ReadString("Hist2"));
  HistList->Add(reg->ReadString("Hist3"));
  HistList->Add(reg->ReadString("Hist4"));
  delete reg;                       //   reg
}
//---------------------------------------------------------------
//     File
void __fastcall TMainForm::File1Click(TObject *Sender)
{
  for (int i=0; i<HistCount; i++)
    if (HistList->Strings[i] != "")
    { //       HistList
      //      
      HistSeparator->Visible = true;
      File1->Items[Hist1->MenuIndex+i]->Visible = true;
      File1->Items[Hist1->MenuIndex+i]->Caption = "&" +
             IntToStr(i+1) + " " + HistList->Strings[i];
    }
}
//---------------------------------------------------------------
//       
void __fastcall TMainForm::HistItemClick(TObject *Sender)
{
  TMenuItem* ItemClicked = dynamic_cast<TMenuItem*>(Sender);
  //  i -      
  int i = ItemClicked->MenuIndex - Hist1->MenuIndex;
  //         RichEdit1
  CreateMDIChild(HistList->Strings[i]);
  Child->RichEdit1->Lines->LoadFromFile(HistList->Strings[i]);
}
//---------------------------------------------------------------
void __fastcall	TMainForm::WmDropFiles(TWMDropFiles& Message)
{ char  buff[MAX_PATH];             //    
  HDROP hDrop = (HDROP)Message.Drop;
  int nFiles = DragQueryFile(hDrop, -1, NULL, NULL);
  for (int i=0; i<nFiles; i++)
  { DragQueryFile(hDrop, i, buff, sizeof(buff));
    FName = buff;
    //        RichEdit1
    CreateMDIChild(FName);          //  -  
    Child->RichEdit1->Lines->LoadFromFile(FName);
  }
  DragFinish(hDrop);                //  
}
//---------------------------------------------------------------
//    Child   RichEdit1  
void __fastcall TMainForm::CreateMDIChild(String Name)
{ static int i;
  Child = new TMDIChild(Application);
  Child->Caption = Name;
  Child->RichEdit1->Clear();    //   
  ActiveMDIChild->Tag = i++;    //   
  ChildList->Add(Child);        //  Child  
  if (FileExists(Name))         //  
  { Child->RichEdit1->Lines->LoadFromFile(Name);
    if (HistList->IndexOf(OpenDialog->FileName) == -1)
    { //       HistList
      HistList->Insert(0, OpenDialog->FileName);
      //     HistList
      if (HistList->Count > HistCount)
        HistList->Delete(HistCount);
    }
  }
}
//---------------------------------------------------------------
//   File|New -   
void __fastcall TMainForm::FileNew1Execute(TObject *Sender)
{
  FName = "";
  CreateMDIChild("NONAME" + IntToStr(MDIChildCount+1));
}
//---------------------------------------------------------------
//   File|Open -   FName   
void __fastcall TMainForm::FileOpen1Execute(TObject *Sender)
{
  if (OpenDialog->Execute())
  { FName = OpenDialog->FileName;
    CreateMDIChild(FName);
  }
}
//---------------------------------------------------------------
//   File|Save -     
void __fastcall TMainForm::FileSave1Execute(TObject *Sender)
{
  if (FName == "")
    FileSaveAs1Execute(Sender);
  else
  { Child = (TMDIChild *)ChildList->Items[ActiveMDIChild->Tag];
    Child->RichEdit1->Lines->SaveToFile(FName);
  }
}
//---------------------------------------------------------------
//   File|Save As -     
void __fastcall TMainForm::FileSaveAs1Execute(TObject *Sender)
{
  SaveDialog->InitialDir = GetCurrentDir();
  if (SaveDialog->Execute())
  { FName = SaveDialog->FileName;
    Child = (TMDIChild *)ChildList->Items[ActiveMDIChild->Tag];
    Child->RichEdit1->Lines->SaveToFile(FName);
  }
}
//---------------------------------------------------------------
//   Edit|Find -   
void __fastcall TMainForm::EditFind1Execute(TObject *Sender)
{
  Child = (TMDIChild *)ChildList->Items[ActiveMDIChild->Tag];
  FindDialog1->FindText = Child->RichEdit1->SelText;
  FindDialog1->Execute();
}
//---------------------------------------------------------------
//   Edit|Replace -   
void __fastcall TMainForm::EditReplace1Execute(TObject *Sender)
{
  Child = (TMDIChild *)ChildList->Items[ActiveMDIChild->Tag];
  ReplaceDialog1->FindText = Child->RichEdit1->SelText;
  ReplaceDialog1->Execute();
  Count = 1;
}
//---------------------------------------------------------------
//    OnFind    
void __fastcall TMainForm::FindDialog1Find(TObject *Sender)
{
  TFindDialog *fd = dynamic_cast<TFindDialog *>(Sender);
  TSearchTypes st;
  if (fd->Options.Contains(frMatchCase)) st << stMatchCase;
  if (fd->Options.Contains(frWholeWord)) st << stWholeWord;
  if (Child->RichEdit1->SelLength)
    Child->RichEdit1->SelStart += 1;    //  
  //       "pos"
  int pos = Child->RichEdit1->FindText(fd->FindText,
            Child->RichEdit1->SelStart,
            Child->RichEdit1->Text.Length(), st);
  //   ,   
  //      
  if (pos != -1)
  { Child->RichEdit1->SelStart = pos;
    Child->RichEdit1->SelLength = fd->FindText.Length();
    Child->RichEdit1->Perform(EM_SCROLLCARET, 0, 0);
    Count++;                        //   
    SetFocus();
  }
  else
  { if (fd == FindDialog1)
      MessageBox(NULL, " ", "  ", MB_OK);
    else
    { String str = "   " + IntToStr(Count) + " ";
      MessageBox(NULL, " ", str.c_str(), MB_OK);
    }
    Count = 0;
    Child->RichEdit1->SelStart = 0;
  }
}
//---------------------------------------------------------------
//    OnReplace  
void __fastcall TMainForm::ReplaceDialog1Replace(TObject *Sender)
{
  Child = (TMDIChild *)ChildList->Items[ActiveMDIChild->Tag];
  if (Child->RichEdit1->SelLength == 0)
    FindDialog1Find(Sender);        //  
  else
  { Child->RichEdit1->SelText = ReplaceDialog1->ReplaceText;
    FindDialog1Find(Sender);        //    
  }
  if (ReplaceDialog1->Options.Contains(frReplaceAll))
    while (Child->RichEdit1->SelLength != 0)
      ReplaceDialog1Replace(Sender);    //  
}
//---------------------------------------------------------------
//   Help|About -  
void __fastcall TMainForm::HelpAbout1Execute(TObject *Sender)
{
  AboutBox->ShowModal();
}
//---------------------------------------------------------------
//   File|Exit -   
void __fastcall TMainForm::FileExit1Execute(TObject *Sender)
{
  TRegistry* reg = new TRegistry;  //   reg
  if (CheckBox1->Checked)
    reg->DeleteKey(RegKey);        //   RegKey
  else
  { reg->OpenKey(RegKey, true);    //   RegKey
    //  HistList   
    reg->WriteString("Hist1", HistList->Strings[0]);
    reg->WriteString("Hist2", HistList->Strings[1]);
    reg->WriteString("Hist3", HistList->Strings[2]);
    reg->WriteString("Hist4", HistList->Strings[3]);
  }
  delete ChildList;                //   ChildList
  delete reg;                      //   reg
  delete HistList;                 //   HistList
  Close();
}
//---------------------------------------------------------------

