//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "MaskMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
Graphics::TBitmap *Backgr,   *Sprite;
unsigned char     *BackBits, *SpriteBits;
BITMAPINFO        *BackInfo, *SpriteInfo;
unsigned int       InfoSize,  ImageSize;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner)
{ Backgr = new Graphics::TBitmap();
  Backgr->LoadFromFile("Mount.bmp");
  Sprite = new Graphics::TBitmap();
  Sprite->LoadFromFile("Plane.bmp");
  GetDIBSizes(Backgr->Handle, InfoSize, ImageSize);
  BackInfo = (BITMAPINFO *) new char[InfoSize];
  memset(BackInfo, 0, InfoSize);
  //   BackInfo   
  BackInfo->bmiHeader.biWidth		= Backgr->Width;
  BackInfo->bmiHeader.biHeight		= -Backgr->Height;
  BackInfo->bmiHeader.biPlanes      = 1;
  BackInfo->bmiHeader.biBitCount    = 8;
  BackInfo->bmiHeader.biCompression = BI_RGB;
  BackInfo->bmiHeader.biSize        = sizeof(BITMAPINFOHEADER);
  //    DIB    
  BackBits = new unsigned char [ImageSize];
  //      DIB
  GetDIBits(Canvas->Handle, Backgr->Handle, 0, Backgr->Height,
            BackBits, BackInfo, DIB_RGB_COLORS);

  GetDIBSizes(Sprite->Handle, InfoSize, ImageSize);
  SpriteInfo = (BITMAPINFO *) new char[InfoSize];
  memset(SpriteInfo, 0, InfoSize);
  //   SpriteInfo   
  SpriteInfo->bmiHeader.biWidth     = Sprite->Width;
  SpriteInfo->bmiHeader.biHeight    = -Sprite->Height;
  SpriteInfo->bmiHeader.biPlanes    = 1;
  SpriteInfo->bmiHeader.biBitCount  = 8;
  SpriteInfo->bmiHeader.biCompression = BI_RGB;
  SpriteInfo->bmiHeader.biSize      = sizeof(BITMAPINFOHEADER);
  //    DIB    
  SpriteBits = new unsigned char [ImageSize];
  //     DIB
  GetDIBits(Canvas->Handle, Sprite->Handle, 0, Sprite->Height,
            SpriteBits, SpriteInfo, DIB_RGB_COLORS);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseDown(TObject *Sender,
    TMouseButton Button, TShiftState Shift, int X, int Y)
{ for (int y=0; y<Sprite->Height; y++)
    for (int x=0; x<Sprite->Width; x++)
    { unsigned char sp = SpriteBits[y*Sprite->Width+x];
      if (sp)       //     ?
        BackBits[(Y+y)*Backgr->Width+X+x] = sp;
    }
  //       DIB
  SetDIBitsToDevice(Canvas->Handle, 0, 0, Backgr->Width,
                    Backgr->Height, 0, 0, 0, Backgr->Height,
                    BackBits, BackInfo, DIB_RGB_COLORS);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{ delete[] SpriteBits;
  delete Sprite;
  delete[] BackBits;
  delete Backgr;
}
//---------------------------------------------------------------------------

