//-----------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <stdlib.h>
#include <math.h>
#include "LedMain.h"
//-----------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TLedForm *LedForm;
//-----------------------------------------------------------------
__fastcall TLedForm::TLedForm(TComponent* Owner) : TForm(Owner)
{ W = Display->Width;               H = Display->Height;
  Application->OnIdle = &WhenIdle;  //    OnIdle
  memset (xIm, 0, sizeof(xIm));     Length = xRe[0] = 256;
}
//-----------------------------------------------------------------
void __fastcall TLedForm::FormCreate(TObject *Sender)
{ Ledgrid = new Graphics::TBitmap;
  Ledgrid->PixelFormat = pf8bit;    Ledgrid->IgnorePalette = true;
  Ledgrid->Width = W;               Ledgrid->Height = H;
  Ledmask = new Graphics::TBitmap;
  Ledmask->LoadFromFile("Ledmask.bmp");
  Ledmask->Transparent = true;
}
//-----------------------------------------------------------------
void __fastcall TLedForm::WhenIdle(TObject *Sender, bool &Done)
{ Done = false;                     SpectrumGenerator();
}
//-----------------------------------------------------------------
void __fastcall TLedForm::SpectrumGenerator(void)
{ //         Display
  XScale = UpDownX->Position;       YScale = UpDownY->Position;
  YLevel = H*UpDownD->Position/100;
  Ledgrid->Canvas->Brush->Color = clMaroon;
  Ledgrid->Canvas->FillRect(Rect(0, 0, W, YLevel));
  Ledgrid->Canvas->Brush->Color = clTeal;
  Ledgrid->Canvas->FillRect(Rect(0, YLevel, W, H));
  for (int x=1; x<Length-1; x++)    //  sin 
    xRe[x] = sin(M_PI/x)*random(H-YLevel);
  DFFT(Length, xRe, xIm, yRe, yIm); //  
  for (int x=0; x<Length/2+1; x++)  //  
    Row[x] = sqrt(yRe[x]*yRe[x]+yIm[x]*yIm[x]);
  int Peaks = 0;                    int w = W*2/Length;
  for (int x=0; x<Length/2; x++)
  { int X = x*w;                    int Y = Row[x]*H/Row[0];
    Ledgrid->Canvas->Brush->Color = clLime;
    Ledgrid->Canvas->Rectangle(X, H-Y, X+w, H);
    if (Y > H-YLevel)               //   ?
    { Peaks++;
      Ledgrid->Canvas->Brush->Color = clRed;
      Ledgrid->Canvas->Rectangle(X, H-Y, X+w, YLevel);
    }
  }
  Display->Canvas->Draw(0, 0, Ledgrid);
  Display->Canvas->Draw(0, 0, Ledmask);
  Caption = " Spectrum Analyzer: " + IntToStr(Peaks) + " peaks detected";
}
//-----------------------------------------------------------------
void __fastcall TLedForm::UpDownLClick(TObject *Sender, TUDBtnType Button)
{ Length = 2<<UpDownL->Position;
  EditL->Text = IntToStr(Length);
}
//-----------------------------------------------------------------
void __fastcall TLedForm::FormDestroy(TObject *Sender)
{ delete Ledgrid;                delete Ledmask;
}
//-----------------------------------------------------------------

