//-----------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Plasma.h"
#include <math.h>
//-----------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSkyForm *SkyForm;
//-----------------------------------------------------------------
__fastcall TSkyForm::TSkyForm(TComponent* Owner) : TForm(Owner)
{ Application->OnIdle = &WhenIdle;  //    OnIdle
}
//-----------------------------------------------------------------
void __fastcall TSkyForm::FormCreate(TObject *Sender)
{ Plasmap = new Graphics::TBitmap;
  Plasmap->PixelFormat = pf32bit;   Plasmap->IgnorePalette = true;
  Plasmap->Width = ClientWidth;     Plasmap->Height = ClientHeight;
  for (int x=0; x<256; x++)
    PlasmaTab[x] = 32 * (1 + sin(x*2*M_PI/255));
}
//-----------------------------------------------------------------
void __fastcall TSkyForm::WhenIdle(TObject *Sender, bool &Done)
{ Done = false;                     PlasmaGenerator();
}
//-----------------------------------------------------------------
void __fastcall TSkyForm::PlasmaGenerator(void)
{ static Byte Yold_pos=0, Yold_asp=0, Xold_pos=0, Xold_asp=0;
  Byte Ynew_pos = Yold_pos;         Byte Ynew_asp = Yold_asp;
  for (int y=0; y<Plasmap->Height; y++)
  { unsigned int *LinePtr = (unsigned int *)Plasmap->ScanLine[y];
    Byte Xnew_pos = Xold_pos;       Byte Xnew_asp = Xold_asp;
    for (int x=0; x<Plasmap->Width; x++)
    { //   x- y-  
      Byte Color = PlasmaTab[Ynew_pos] + PlasmaTab[Ynew_asp] +
                   PlasmaTab[Xnew_pos] + PlasmaTab[Xnew_asp];
      //    RGB-
      LinePtr[x] = ((255-Color)<<16 | Color<<8 | 128+(Color>>1));
      Xnew_pos += 1;                Xnew_asp += 7;
    }
    Ynew_pos += 2;                  Ynew_asp += 1;
  }
  //        
  Xold_pos -= 2;                    Xold_asp += random(8);
  Yold_pos += 4;                    Yold_asp -= random(6);
  Canvas->Draw(0, 0, Plasmap);      //   
}
//-----------------------------------------------------------------
void __fastcall TSkyForm::FormDestroy(TObject *Sender)
{ delete Plasmap;
}
//-----------------------------------------------------------------
void __fastcall TSkyForm::FormResize(TObject *Sender)
{ Plasmap->Width = ClientWidth;     Plasmap->Height = ClientHeight;
}
//-----------------------------------------------------------------

